.686p
.MODEL FLAT,SYSCALL

CPUFEATURES STRUCT
bfVersionInfo DD ?
bfAddInfo DD ?
ulBaseFeatures DD ?
ulExtendedFeatures DD ?
CPUFEATURES ENDS

PCPUFEATURES TYPEDEF PTR CPUFEATURES


.CODE
; NOTE: a hidden parameter will be passed from C-Code as the leftmost
; parameter to contain the address of the 64-bit result variable
ReadMSR PROC PUBLIC USES ebx,resultAddr:DWORD,regNo:DWORD
   mov ebx,resultAddr
   mov ecx,regNo
   rdmsr
   mov [ebx],eax
   mov [ebx+4],edx
   ret
ReadMSR ENDP


IsAMD PROC PUBLIC USES ebx
   xor eax,eax
   cpuid
   xor eax,eax
   cmp ebx,68747541h
   jne short @F
   cmp ecx,444D4163h
   jne short @F
   cmp edx,69746E65h
   jne short @F
   mov eax,1
@@:
   ret
IsAMD ENDP

GetCPUFeatures PROC PUBLIC USES ebx ecx edx esi,p:PCPUFEATURES
    mov eax,1
    cpuid

    ASSUME esi:PCPUFEATURES
    mov esi,p
    mov [esi].bfVersionInfo,eax
    mov [esi].bfAddInfo,ebx
    mov [esi].ulBaseFeatures,edx
    mov [esi].ulExtendedFeatures,ecx

    mov eax,1
    jmp short @@exit
@@fail:
    xor eax,eax
@@exit:
    ret
GetCPUFeatures ENDP



END
